diff --git a/src/common/resources/lang/en_US/gui.lang b/src/common/resources/lang/en_US/gui.lang
index 03fe0ba6e..74cfb7f12 100644
--- a/src/common/resources/lang/en_US/gui.lang
+++ b/src/common/resources/lang/en_US/gui.lang
@@ -94,6 +94,9 @@ gui.create_world.pages.game_rules.title=Game Rules
 gui.dispenser.label.dispenser=Dispenser
 gui.dispenser.label.inventory=Inventory
 
+gui.activator.label.activator=Activator
+gui.activator.label.inventory=Inventory
+
 gui.downloading_terrain.label.title=Downloading Terrain
 
 gui.edit_flag.label.inventory=Inventory
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index 67b1155a2..efe8d6ff9 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -1311,7 +1311,7 @@ public class Minecraft
 
     private void clickMiddleMouseButton()
     {
-        HitResult mouseOver = thePlayer.rayTrace(256, timer.partialTicks);
+        HitResult mouseOver = thePlayer.rayTrace(256, timer.partialTicks, false, false);
         if(mouseOver != null && mouseOver.hitType == HitResult.HitType.TILE)
         {
             int x = mouseOver.x;
@@ -2213,18 +2213,20 @@ public class Minecraft
         if(theWorld != null)
         {
             theWorld.saveWorldIndirectly(loadingScreen);
-            IChunkLoader loader = theWorld.saveHandler.getChunkLoader(theWorld.dimension);
-            if (loader != null) {
-                while (loader.isSaving()) {
-                    try {
-                        Thread.sleep(1);
-                    } catch (InterruptedException e) {
-                        throw new RuntimeException(e);
+            if (theWorld.saveHandler != null) {
+                IChunkLoader loader = theWorld.saveHandler.getChunkLoader(theWorld.dimension);
+                if (loader != null) {
+                    while (loader.isSaving()) {
+                        try {
+                            Thread.sleep(1);
+                        } catch (InterruptedException e) {
+                            throw new RuntimeException(e);
+                        }
                     }
                 }
+                theWorld.getChunkProvider().unloadAllChunks();
+                theWorld.onUnload();
             }
-            theWorld.getChunkProvider().unloadAllChunks();
-            theWorld.onUnload();
         }
         theWorld = world;
         if(world != null)
diff --git a/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
index 980d205bf..7d2bb10e1 100644
--- a/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
+++ b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
@@ -6,6 +6,7 @@ import com.mojang.nbt.CompoundTag;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.particle.TakeAnimationParticle;
+import net.minecraft.client.gui.container.ActivatorScreen;
 import net.minecraft.client.gui.container.ContainerScreen;
 import net.minecraft.client.gui.container.CraftingScreen;
 import net.minecraft.client.gui.container.DispenserScreen;
@@ -26,6 +27,7 @@ import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.client.gui.toasts.AchievementToast;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.PortalBlock;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.entity.DispenserBlockEntity;
 import net.minecraft.core.block.entity.FlagBlockEntity;
 import net.minecraft.core.block.entity.FurnaceBlockEntity;
@@ -318,6 +320,12 @@ public class LocalPlayer extends Player
         mc.displayScreen(new DispenserScreen(inventory, blockEntity));
     }
 
+    @Override
+    public void displayActivatorScreen(ActivatorBlockEntity blockEntity)
+    {
+        mc.displayScreen(new ActivatorScreen(inventory, blockEntity));
+    }
+
     @Override
     public void displayGuidebookScreen() {
         mc.displayScreen(new GuidebookScreen(mc.currentScreen));
diff --git a/src/main/java/net/minecraft/client/gui/container/ActivatorScreen.java b/src/main/java/net/minecraft/client/gui/container/ActivatorScreen.java
new file mode 100644
index 000000000..d280e7c08
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/container/ActivatorScreen.java
@@ -0,0 +1,77 @@
+package net.minecraft.client.gui.container;
+
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.player.inventory.container.Inventory;
+import net.minecraft.core.player.inventory.menu.ActivatorMenu;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Listener;
+import org.lwjgl.opengl.GL11;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class ActivatorScreen extends AbstractContainerScreen {
+    protected final ActivatorBlockEntity activatorBlockEntity;
+    protected final List<ButtonElement> slotButtons = new ArrayList<>();
+
+    public ActivatorScreen(Inventory inventory, ActivatorBlockEntity activatorBlock) {
+        super(new ActivatorMenu(inventory, activatorBlock));
+        this.activatorBlockEntity = activatorBlock;
+    }
+
+    @Override
+    public void init() {
+        super.init();
+        int xLeft = (width - xSize) / 2;
+        int yTop = (height - ySize) / 2;
+        final int startX = xLeft + 7;
+        final int startY = yTop + 34;
+        buttons.clear();
+        slotButtons.clear();
+        for (int i = 0; i < activatorBlockEntity.getContainerSize(); i++) {
+            ButtonElement button = new ButtonElement(i, startX + 18 * i, startY, 18, 18, "");
+            button.visible = false;
+            slotButtons.add(button);
+        }
+    }
+
+    @Override
+    public void mouseClicked(int mx, int my, int buttonNum) {
+        if (buttonNum == 1 && mc.thePlayer.inventory.getHeldItemStack() == null) {
+            for (ButtonElement button : slotButtons) {
+                if (activatorBlockEntity.getItem(button.id) == null && button.mouseClicked(mc, mx, my)) {
+                    activatorBlockEntity.lockSlot(button.id, !activatorBlockEntity.locked(button.id));
+                    if (button.playSound) {
+                        mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+                    }
+                    break;
+                }
+            }
+        }
+        super.mouseClicked(mx, my, buttonNum);
+    }
+
+    @Override
+    protected void drawGuiContainerForegroundLayer() {
+        font.drawString(I18n.getInstance().translateKey("gui.activator.label.activator"), 60, 6, 0x404040);
+        font.drawString(I18n.getInstance().translateKey("gui.activator.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
+    }
+
+    @Override
+    protected void drawGuiContainerBackgroundLayer(float f) {
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/activator.png").bind();
+        int xLeft = (width - xSize) / 2;
+        int yTop = (height - ySize) / 2;
+        drawTexturedModalRect(xLeft, yTop, 0, 0, xSize, ySize);
+
+        if (!activatorBlockEntity.locked(activatorBlockEntity.stackSelector)) { // Draw selector arrow
+            final int startX = xLeft + 7;
+            final int startY = yTop + 26;
+            drawTexturedModalRect( startX + 18 * activatorBlockEntity.stackSelector, startY, 176, 0, 18, 34);
+        }
+    }
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/gui/container/DispenserScreen.java b/src/main/java/net/minecraft/client/gui/container/DispenserScreen.java
index 75f11ba4a..29f566d73 100644
--- a/src/main/java/net/minecraft/client/gui/container/DispenserScreen.java
+++ b/src/main/java/net/minecraft/client/gui/container/DispenserScreen.java
@@ -6,10 +6,6 @@ import net.minecraft.core.player.inventory.menu.TrapMenu;
 import net.minecraft.core.player.inventory.container.Inventory;
 import org.lwjgl.opengl.GL11;
 
-// Referenced classes of package net.minecraft.src:
-//            GuiContainer, ContainerDispenser, FontRenderer, RenderEngine, 
-//            InventoryPlayer, DispenserBlockEntity
-
 public class DispenserScreen extends AbstractContainerScreen
 {
 
diff --git a/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java b/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
index 5589746bb..a2b9e58b6 100644
--- a/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
+++ b/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
@@ -56,7 +56,7 @@ public class ClientCommandSource implements CommandSource {
 
     @Override
     public @NotNull Vec3 getCoordinates(boolean offsetHeight) {
-        Vec3 position = this.getSender().getPosition(1.0f);
+        Vec3 position = this.getSender().getPosition(1.0f, false);
         if (offsetHeight) return position.add(0.0f, -this.getSender().heightOffset, 0.0f);
         return position;
     }
diff --git a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
index 069b0d57b..c56abf098 100644
--- a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
@@ -17,6 +17,7 @@ import net.minecraft.client.player.controller.PlayerControllerMP;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.Global;
 import net.minecraft.core.achievement.stat.StatList;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.entity.BlastFurnaceBlockEntity;
 import net.minecraft.core.block.entity.BlockEntityDispatcher;
@@ -850,45 +851,56 @@ public class ClientPacketHandler extends PacketHandler
     @Override
     public void handleOpenWindow(ContainerOpenPacket containerOpenPacket)
     {
-        if (containerOpenPacket.inventoryType == 0)
-        {
-            SimpleContainer simpleContainer = new SimpleContainer(containerOpenPacket.windowTitle, containerOpenPacket.slotsCount);
-            mc.thePlayer.displayContainerScreen(simpleContainer);
-            mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
-        }
-        else if (containerOpenPacket.inventoryType == 2)
-        {
-            FurnaceBlockEntity furnaceBlockEntity = new FurnaceBlockEntity();
-            mc.thePlayer.displayFurnaceScreen(furnaceBlockEntity);
-            mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
-        }
-        else if (containerOpenPacket.inventoryType == 3)
-        {
-            DispenserBlockEntity dispenserBlockEntity = new DispenserBlockEntity();
-            mc.thePlayer.displayDispenserScreen(dispenserBlockEntity);
-            mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
-        }
-        else if (containerOpenPacket.inventoryType == 4)
-        {
-            BlastFurnaceBlockEntity blastFurnaceBlockEntity = new BlastFurnaceBlockEntity();
-            mc.thePlayer.displayFurnaceScreen(blastFurnaceBlockEntity);
-            mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
-        }
-        else if (containerOpenPacket.inventoryType == 5)
-        {
-            TrommelBlockEntity trommelBlockEntity = new TrommelBlockEntity();
-            mc.thePlayer.displayTrommelScreen(trommelBlockEntity);
-            mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
-        }
-        else if (containerOpenPacket.inventoryType == 7)
-        {
-            mc.thePlayer.displayPaintingPickerScreen();
-        }
-        else if (containerOpenPacket.inventoryType == 1)
-        {
-            LocalPlayer localPlayer = mc.thePlayer;
-            mc.thePlayer.displayWorkbenchScreen(MathHelper.floor(localPlayer.x), MathHelper.floor(localPlayer.y), MathHelper.floor(localPlayer.z));
-            mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
+        switch (containerOpenPacket.inventoryType) {
+            case ContainerOpenPacket.TYPE_GENERIC_CONTAINER: {
+                SimpleContainer simpleContainer = new SimpleContainer(containerOpenPacket.windowTitle, containerOpenPacket.slotsCount);
+                mc.thePlayer.displayContainerScreen(simpleContainer);
+                mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
+                break;
+            }
+            case ContainerOpenPacket.TYPE_FURNACE: {
+                FurnaceBlockEntity furnaceBlockEntity = new FurnaceBlockEntity();
+                mc.thePlayer.displayFurnaceScreen(furnaceBlockEntity);
+                mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
+                break;
+            }
+            case ContainerOpenPacket.TYPE_DISPENSER: {
+                DispenserBlockEntity dispenserBlockEntity = new DispenserBlockEntity();
+                mc.thePlayer.displayDispenserScreen(dispenserBlockEntity);
+                mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
+                break;
+            }
+            case ContainerOpenPacket.TYPE_ACTIVATOR: {
+                ActivatorBlockEntity activatorBlockEntity = new ActivatorBlockEntity();
+                mc.thePlayer.displayActivatorScreen(activatorBlockEntity);
+                mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
+                break;
+            }
+            case ContainerOpenPacket.TYPE_BLAST_FURNACE: {
+                BlastFurnaceBlockEntity blastFurnaceBlockEntity = new BlastFurnaceBlockEntity();
+                mc.thePlayer.displayFurnaceScreen(blastFurnaceBlockEntity);
+                mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
+                break;
+            }
+            case ContainerOpenPacket.TYPE_TROMMEL: {
+                TrommelBlockEntity trommelBlockEntity = new TrommelBlockEntity();
+                mc.thePlayer.displayTrommelScreen(trommelBlockEntity);
+                mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
+                break;
+            }
+            case ContainerOpenPacket.TYPE_PAINTING: {
+                mc.thePlayer.displayPaintingPickerScreen();
+                break;
+            }
+            case ContainerOpenPacket.TYPE_CRAFTING: {
+                LocalPlayer localPlayer = mc.thePlayer;
+                mc.thePlayer.displayWorkbenchScreen(MathHelper.floor(localPlayer.x), MathHelper.floor(localPlayer.y), MathHelper.floor(localPlayer.z));
+                mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
+                break;
+            }
+            default: {
+                LOGGER.warn("No defined before for container open '{}' with type {}!", containerOpenPacket.windowId, containerOpenPacket.inventoryType);
+            }
         }
     }
 
@@ -1037,7 +1049,7 @@ public class ClientPacketHandler extends PacketHandler
     @Override
     public void handlePlaySoundEffect(PlaySoundEffectPacket playsoundeffectPacket)
     {
-        mc.theWorld.playSoundEffect(playsoundeffectPacket.soundID, playsoundeffectPacket.x, playsoundeffectPacket.y, playsoundeffectPacket.z, playsoundeffectPacket.data);
+        mc.theWorld.playBlockEvent(playsoundeffectPacket.soundID, playsoundeffectPacket.x, playsoundeffectPacket.y, playsoundeffectPacket.z, playsoundeffectPacket.data);
     }
 
 	@Override
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index c4353c224..0f19816c7 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -161,7 +161,7 @@ public abstract class PlayerController {
 			heldItem = heldItemStack.getItem();
 		}
 		
-		world.playSoundEffect(EVENT_BLOCK_BREAK, x, y, z, block.id);
+		world.playBlockEvent(EVENT_BLOCK_BREAK, x, y, z, block.id);
 		int meta = world.getBlockMetadata(x, y, z);
 		boolean removed = world.setBlockWithNotify(x, y, z, 0);
 		if(removed) {
diff --git a/src/main/java/net/minecraft/client/render/RenderBlockCache.java b/src/main/java/net/minecraft/client/render/RenderBlockCache.java
index e700d2b2c..750a10e9c 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlockCache.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlockCache.java
@@ -91,7 +91,7 @@ final public class RenderBlockCache {
     	int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
     	if(!lightmapCoordCached[index]) {
     		int lightEmission = Block.lightEmission[block.id];
-    		lightmapCoordValue[index] = access.getLightmapCoord(relX + offsetX, relY + offsetY, relZ + offsetZ, lightEmission >= 15 ? 15 : 0);
+    		lightmapCoordValue[index] = access.getLightmapCoord(relX + offsetX, relY + offsetY, relZ + offsetZ, lightEmission);
     		lightmapCoordCached[index] = true;
     	}
     	return lightmapCoordValue[index];
diff --git a/src/main/java/net/minecraft/client/render/RenderBlocks.java b/src/main/java/net/minecraft/client/render/RenderBlocks.java
index ac192d9ad..c6e406798 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -273,20 +273,21 @@ public class RenderBlocks
                                     int topX, int topY, int topZ, float topP, float botP,
                                     int lefX, int lefY, int lefZ, float lefP, float rigP){
     	boolean ao = mc.isAmbientOcclusionEnabled() && Block.lightEmission[block.id] == 0;
-        
+        boolean isFullCube = depth <= FULL_CUBE_THRESHOLD;
+
     	if(LightmapHelper.isLightmapEnabled()) {
     		if(overbright) {
     			int dirX2 = dirX;
     			int dirY2 = dirY;
     			int dirZ2 = dirZ;
     			
-    			if(depth > FULL_CUBE_THRESHOLD) {
+    			if(!isFullCube) {
     				dirX2 = 0;
     				dirY2 = 0;
     				dirZ2 = 0;
     			}
     			
-    			int lmc = LightmapHelper.getOverbrightLightmapCoord(blockAccess.getSavedLightValue(LightLayer.Sky, x + dirX2, y + dirY2, z + dirZ2));
+    			int lmc = LightmapHelper.getOverbrightLightmapCoord(blockAccess.getSavedLightValue(LightLayer.Sky, dirX2, dirY2, dirZ2));
     			
         		lightmapCoordTopLeft = lightmapCoordBottomLeft = lightmapCoordBottomRight = lightmapCoordTopRight = lmc;
     		}else {
@@ -295,7 +296,7 @@ public class RenderBlocks
         			int dirY2 = dirY;
         			int dirZ2 = dirZ;
         			
-        			if(depth > FULL_CUBE_THRESHOLD) {
+        			if(!isFullCube) {
         				dirX2 = 0;
         				dirY2 = 0;
         				dirZ2 = 0;
@@ -329,7 +330,7 @@ public class RenderBlocks
         			lightmapCoordBottomRight = LightmapHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
         		}else {
         			int lmc;
-                	if(depth > FULL_CUBE_THRESHOLD) {
+                	if(!isFullCube) {
                 		lmc = block.getLightmapCoord(blockAccess, x, y, z);
                 	}else {
                 		lmc = block.getLightmapCoord(blockAccess, x + dirX, y + dirY, z + dirZ);
@@ -372,7 +373,7 @@ public class RenderBlocks
                     lightBR = (dirB + bB + rB + brB) / 4.0F;
                     lightBL = (lB + blB + dirB + bB) / 4.0F;
                 }
-                if(depth > FULL_CUBE_THRESHOLD){
+                if(!isFullCube){
                     float dirB = cache.getBrightness(0, 0, 0);
                     boolean lefT = cache.getOpacity(lefX, lefY, lefZ);
                     boolean botT = cache.getOpacity(-topX, -topY, -topZ);
@@ -392,7 +393,17 @@ public class RenderBlocks
                     lightBL = (lB + blB + dirB + bB) / 4.0F * depth + lightBL*(1-depth);
                 }
             } else {
-                float brightness = cache.getBrightness(dirX, dirY, dirZ);
+                int dirX2 = dirX;
+                int dirY2 = dirY;
+                int dirZ2 = dirZ;
+
+                if(!isFullCube) {
+                    dirX2 = 0;
+                    dirY2 = 0;
+                    dirZ2 = 0;
+                }
+
+                float brightness = cache.getBrightness(dirX2, dirY2, dirZ2);
                 lightTL = lightBL = lightBR = lightTR = brightness;
             }
         }
diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index cdc71046b..44cc472e5 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -21,6 +21,7 @@ import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.MusicDiscItem;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
@@ -1718,20 +1719,22 @@ public class RenderGlobal
                 break;
 
             case EVENT_DISPENSER_PARTICLES: // Dispenser eject particles
-                int j1 = data % 3 - 1;
-                int k1 = (data / 3) % 3 - 1;
-                double d = (double)x + (double)j1 * 0.6D + 0.5D;
-                double d1 = (double)y + 0.5D;
-                double d2 = (double)z + (double)k1 * 0.6D + 0.5D;
-                for(int l1 = 0; l1 < 10; l1++) {
-                    double d3 = random.nextDouble() * 0.2D + 0.01D;
-                    double d4 = d + (double)j1 * 0.01D + (random.nextDouble() - 0.5D) * (double)k1 * 0.5D;
-                    double d5 = d1 + (random.nextDouble() - 0.5D) * 0.5D;
-                    double d6 = d2 + (double)k1 * 0.01D + (random.nextDouble() - 0.5D) * (double)j1 * 0.5D;
-                    double d7 = (double)j1 * d3 + random.nextGaussian() * 0.01D;
-                    double d8 = -0.03D + random.nextGaussian() * 0.01D;
-                    double d9 = (double)k1 * d3 + random.nextGaussian() * 0.01D;
-                    addParticle("smoke", d4, d5, d6, d7, d8, d9, 0);
+                Direction direction = Direction.getDirectionById(data);
+                int xOff = direction.getOffsetX();
+                int yOff = direction.getOffsetY();
+                int zOff = direction.getOffsetZ();
+                double px = (double)x + (double)xOff * 0.6D + 0.5D;
+                double py = (double)y + (double)yOff * 0.6D + 0.5D;
+                double pz = (double)z + (double)zOff * 0.6D + 0.5D;
+                for(int i = 0; i < 10; i++) {
+                    double rO = random.nextDouble() * 0.2D + 0.01D;
+                    double fx = px + (double)xOff * 0.01D + (random.nextDouble() - 0.5D) * (double)zOff * 0.5D;
+                    double fy = py + (double)yOff * 0.01D + (random.nextDouble() - 0.5D) * (double)yOff * 0.5D;
+                    double fz = pz + (double)zOff * 0.01D + (random.nextDouble() - 0.5D) * (double)xOff * 0.5D;
+                    double mx = (double)xOff * rO + random.nextGaussian() * 0.01D;
+                    double my = (double)yOff * rO + random.nextGaussian() * 0.01D;
+                    double mz = (double)zOff * rO + random.nextGaussian() * 0.01D;
+                    addParticle("smoke", fx, fy, fz, mx, my, mz, 0);
                 }
 
                 break;
diff --git a/src/main/java/net/minecraft/client/render/WorldRenderer.java b/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 82a9c600e..db4b333fb 100644
--- a/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -6,7 +6,6 @@ import java.util.List;
 import java.util.Random;
 
 import com.mojang.logging.LogUtils;
-import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.phys.Vec3;
 import org.lwjgl.input.Mouse;
@@ -128,7 +127,7 @@ public class WorldRenderer
 		final double blockReach = mc.playerController.getBlockReachDistance();
 		final double entityReach = mc.playerController.getEntityReachDistance();
 		
-		Vec3 pos1 = mc.thePlayer.getPosition(partialTicks);
+		Vec3 pos1 = mc.thePlayer.getPosition(partialTicks, false);
 		Vec3 look = mc.thePlayer.getViewVector(partialTicks);
 		Vec3 pos2 = pos1.add(look.x * blockReach, look.y * blockReach, look.z * blockReach);
 		
@@ -136,7 +135,7 @@ public class WorldRenderer
 		mc.objectMouseOver = mc.theWorld.checkBlockCollisionBetweenPoints(pos1, pos2);
 		
 		// Calculate again because block raytrace changes the values
-		pos1 = mc.thePlayer.getPosition(partialTicks);
+		pos1 = mc.thePlayer.getPosition(partialTicks, false);
 		look = mc.thePlayer.getViewVector(partialTicks);
 		pos2 = pos1.add(look.x * entityReach, look.y * entityReach, look.z * entityReach);
 		
diff --git a/src/main/java/net/minecraft/client/render/block/model/ActivatorBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/ActivatorBlockModel.java
new file mode 100644
index 000000000..d9161bf31
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/ActivatorBlockModel.java
@@ -0,0 +1,49 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.ActivatorBlock;
+import net.minecraft.core.block.FullRotatableBlock;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.VeryRotatableEntityBlock;
+import net.minecraft.core.block.RotatableBlock;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.helper.Sides;
+
+public class ActivatorBlockModel extends VeryRotatableBlockModel<ActivatorBlock> {
+    public final IconCoordinate frontPowered = TextureRegistry.getTexture("minecraft:block/activator_front_active");
+    public final IconCoordinate frontOverbright = TextureRegistry.getTexture("minecraft:block/activator_front_active_overlay");
+    public ActivatorBlockModel(Block block) {
+        super(block);
+    }
+
+    @Override
+    public boolean hasOverbright() {
+        return true;
+    }
+
+    @Override
+    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    {
+        boolean isPowered = (data & ActivatorBlock.MASK_POWERED) != 0;
+        final Direction dir = VeryRotatableEntityBlock.metaToDirection(data);
+        if (side == dir.getSide()) {
+            return isPowered ? frontPowered : atlasIndices[Side.TOP.getId()];
+        }
+        if (side == Side.BOTTOM || side == Side.TOP) return atlasIndices[Side.BOTTOM.getId()];
+        if ((dir.getSide() == Side.BOTTOM || dir.getSide() == Side.TOP) && (side == Side.NORTH || side == Side.SOUTH)) return atlasIndices[Side.BOTTOM.getId()];
+        return side.getDirection() != dir.getOpposite() ? atlasIndices[Side.NORTH.getId()] : atlasIndices[Side.BOTTOM.getId()];
+    }
+
+    @Override
+    public IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data)
+    {
+        boolean isPowered = (data & ActivatorBlock.MASK_POWERED) != 0;
+        if(isPowered && side.getId() == FullRotatableBlock.metaToDirection(data).getSide().getId())
+        {
+            return frontOverbright;
+        }
+        return null;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/AxisAlignedBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/AxisAlignedBlockModel.java
index 235d662c3..c1a7398b1 100644
--- a/src/main/java/net/minecraft/client/render/block/model/AxisAlignedBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/AxisAlignedBlockModel.java
@@ -3,8 +3,10 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.AxisAlignedBlock;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.RotatableBlock;
+import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 
@@ -16,23 +18,23 @@ public class AxisAlignedBlockModel<T extends Block> extends StandardBlockModel<T
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
-        int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        int i1 = RotatableBlock.getOrientation(l);
-        switch(i1)
+        int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+        Axis axis = AxisAlignedBlock.metaToAxis(meta);
+        switch(axis)
         {
-            case 0: // '\0'
+            case Y: // '\0'
                 renderBlocks.uvRotateEast = 0;
                 renderBlocks.uvRotateWest = 0;
                 renderBlocks.uvRotateSouth = 0;
                 renderBlocks.uvRotateNorth = 0;
                 break;
 
-            case 1: // '\002'
+            case Z: // '\002'
                 renderBlocks.uvRotateSouth = 1;
                 renderBlocks.uvRotateNorth = 1;
                 break;
 
-            case 2: // '\002'
+            case X: // '\002'
                 renderBlocks.uvRotateEast = 1;
                 renderBlocks.uvRotateWest = 1;
                 renderBlocks.uvRotateTop = 1;
